八码数——hdu 1043

The 15-puzzle has been around for over 100 years; even if you don‘t know it by that name, you‘ve seen it. It is constructed with 15 sliding tiles, each with a number from 1 to 15 on it, and all packed into a 4 by 4 frame with one tile missing. Let‘s call the missing tile ‘x‘; the object of the puzzle is to arrange the tiles so that they are ordered as:

 1  2  3  4 5  6  7  8 9 10 11 1213 14 15  x

where the only legal operation is to exchange ‘x‘ with one of the tiles with which it shares an edge. As an example, the following sequence of moves solves a slightly scrambled puzzle:

 1  2  3  4     1  2  3  4     1  2  3  4     1  2  3  4 5  6  7  8     5  6  7  8     5  6  7  8     5  6  7  8 9  x 10 12     9 10  x 12     9 10 11 12     9 10 11 1213 14 11 15    13 14 11 15    13 14  x 15    13 14 15  x            r->            d->            r->

The letters in the previous row indicate which neighbor of the ‘x‘ tile is swapped with the ‘x‘ tile at each step; legal values are ‘r‘,‘l‘,‘u‘ and ‘d‘, for right, left, up, and down, respectively.

Not all puzzles can be solved; in 1870, a man named Sam Loyd was famous for distributing an unsolvable version of the puzzle, and

frustrating many people. In fact, all you have to do to make a regular puzzle into an unsolvable one is to swap two tiles (not counting the missing ‘x‘ tile, of course).

In this problem, you will write a program for solving the less well-known 8-puzzle, composed of tiles on a three by three

arrangement.

InputYou will receive, several descriptions of configuration of the 8 puzzle. One description is just a list of the tiles in their initial positions, with the rows listed from top to bottom, and the tiles listed from left to right within a row, where the tiles are represented by numbers 1 to 8, plus ‘x‘. For example, this puzzle

1 2 3

x 4 6

7 5 8

is described by this list:

1 2 3 x 4 6 7 5 8

OutputYou will print to standard output either the word ``unsolvable‘‘, if the puzzle has no solution, or a string consisting entirely of the letters ‘r‘, ‘l‘, ‘u‘ and ‘d‘ that describes a series of moves that produce a solution. The string should include no spaces and start at the beginning of the line. Do not print a blank line between cases.

Sample Input

2  3  4  1  5  x  7  6  8

Sample Output

ullddrurdllurdruldr

题意:

给你一个3*3的九方格,每个格子中放入‘1’~‘8’和‘x‘中的一个,并且每个格子中的字符不相同;

1 2 3
x 4 6

7 5 8

上面的格子序列可以通过输入 12346758来表示。

其中,’能和与它相邻的上下左右四个格子相交换;交换方式用‘u‘,‘d‘,‘l‘,‘r‘表示。问能不能通过有限次的交换,使之变为

1 2 3

4 5 6

7 8 x

即 12345678x

若能输出每一步的路径,若不能输出``unsolvable‘‘;

#include <iostream>
#include<queue>
#include<vector>
#include<algorithm>
#include<cstring>
using namespace std;
int fac[]={1,1,2,6,24,120,720,5040,40320,362880};
const int maxn=370000;
bool vis[maxn];
vector<char>Path[maxn];//若用string来保存,则会MLE
int dxy[4][2]={{-1,0},{1,0},{0,-1},{0,1}};//u,d,l,r;
char index[5]="durl";//要与上面相反,因为是反向搜索
int aim=46234;//123456780的hash值
struct node
{
    int loc;//0的位置
    int state;//哈希值
    int s[9];
    vector<char>path;
};
int cantor(int *s)//康拓展开,求hash值
{
    int ans=0;
    for(int i=0;i<9;i++)
    {
        int num=0;
        for(int j=i+1;j<9;j++)
        {
            if(s[j]<s[i])num++;
        }
        ans+=(num*fac[9-i-1]);
    }
    return ans+1;
}
void bfs()
{
    memset(vis,0,sizeof(vis));
    node cur,nex;
    for(int i=0;i<8;i++)cur.s[i]=i+1;
    cur.s[8]=0;
    cur.loc=8;
    cur.state=aim;
    cur.path.clear();
    queue<node>q;
    q.push(cur);
    vis[aim]=1;
    Path[aim].clear();
    while(!q.empty())
    {
        cur=q.front();
        q.pop();
        int x=cur.loc/3,y=cur.loc%3;
        for(int i=0;i<4;i++)
        {
            int dx=x+dxy[i][0],dy=y+dxy[i][1];
            if(dx<0||dx>2||dy<0||dy>2)continue;
            nex=cur;
            nex.loc=dx*3+dy;
            nex.s[cur.loc]=nex.s[nex.loc];//先交换
            nex.s[nex.loc]=0;//再赋值
            nex.state=cantor(nex.s);
            if(!vis[nex.state])
            {
                vis[nex.state]=1;
                nex.path.insert(nex.path.begin(),index[i]);//插入到第一个位置
                q.push(nex);
                Path[nex.state]=nex.path;
            }

        }
    }
}
int main()
{
    char ch;
    node cur;
    vector<char>v;
    vector<char>::iterator it;
    bfs();
    while(cin>>ch)
    {
        if(ch==‘x‘){cur.s[0]=0;cur.loc=0;}
        else cur.s[0]=ch-‘0‘;
        for(int i=1;i<9;i++)
        {
            cin>>ch;
            if(ch==‘x‘)
            {
                cur.s[i]=0;
                cur.loc=i;
            }
            else cur.s[i]=ch-‘0‘;
        }
        cur.state=cantor(cur.s);
        if(vis[cur.state])
        {
            v=Path[cur.state];
            for(it=v.begin();it!=v.end();it++)
                cout<<*it;
            cout<<endl;

        }
        else cout<<"unsolvable"<<endl;
    }
    return 0;
}

原文地址:https://www.cnblogs.com/175426-hzau-zxjc-con/p/10039810.html

时间: 2024-11-04 07:16:47

八码数——hdu 1043的相关文章

HDU 1043 POJ 1077 八数码问题

以下内容转载自:http://www.cnblogs.com/goodness/archive/2010/05/04/1727141.html 八数码的八境界 研究经典问题,空说不好,我们拿出一个实际的题目来演绎.八数码问题在北大在线测评系统中有一个对应的题,题目描述如下: Eight Time Limit: 1000MS    Memory Limit: 65536K  Special Judge Description The 15-puzzle has been aroundfor ove

HDU 1043 Eight(八数码)

p.MsoNormal { margin: 0pt; margin-bottom: .0001pt; text-align: justify; font-family: Calibri; font-size: 10.5000pt } h1 { margin-top: 5.0000pt; margin-bottom: 5.0000pt; text-align: center; font-family: 宋体; color: rgb(26,92,200); font-weight: bold; fo

HDU - 1043 - Eight / POJ - 1077 - Eight

先上题目: Eight Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 11243    Accepted Submission(s): 3022Special Judge Problem Description The 15-puzzle has been around for over 100 years; even if you

【分享】北京赛车七码八码走势滚雪球规律技巧和打法

这是8码滚雪球分配技巧, 企 下面是八码滚雪球的分配.只是投注金额改变而已 鹅 一次1000分8个号滚3期4期一收,基本1000变2000翻一倍 1 第一期:1000分8个号一个125 中就有1212左右 0 第二期:1212分8个号一个151 中就有1464左右 5 第三期:1464分8个号一个183 中就有1775左右 9 第四期:1775分8个号一个221 中就有 2143左右 8 第五期:2143分8个码一个267 中就有2589左右 8 8码建议3期4期一收.这是8码滚雪球分配技巧 1

看北京赛车八码滚雪球定名选号技巧大盘预测走势规律

我相信能进来看这贴的人都应该清楚北京赛车PK10是什么,又或者已经有人被它搞得伤痕累累.是不是你开始玩这个的时候你觉得钱来的实在太容易了! 你会发现你每天这样赢下去一个月后你就可以买辆宝马了? 但我告诉你,任何以赌钱的心态来玩的,你到最后都会输得一败涂地,所以我们要把它当成一种投资的来看待,以一种理财的方式来投资,投资有风险,必然需要投资者的理智与谨慎!!! 给大家介绍一个冠军与第七名双长龙走势,对于玩赛车的一些看法和滚雪球玩法教学 上图是我在群里发福利计划的时候无意中发现的一个较为稳定的走势,

北京赛车六八码盈利技巧公式规律

知 己 知 彼 者 百 战 不 殆 " - - < 孙 子 · 谋 攻 > . 虽 说 赛 车 不 可 能 百 战 百 胜 , 但 如 果 要 玩 就 必 须 先 了 解 对 手 , 赛 车 中 最 重 要 的 是 要 知 道 参 与 游 戏 的 收 益 率 和 正 确 的 策 略 , 不 参 与 陌 生 的 c a i 种 是 基 本 原 则 ! 首 先 , 一 定 要 用 平 常 心 对 待 , 心 态 一 定 要 好 , 赢 得 时 候 不 能 骄 傲 得 意 忘 形 , 输

第三章 2. 超复数数系,四元数,八元数,十六元数

一.超复数数系 从实数扩展到复数,实际上是从实数轴扩张到复平面,即从一元数扩展到二元数.那么我们能够扩展到更高维的空间哪?数学家给了我们答案,我们可以引进$2^{n}$元数.当$n=0,1$时,分别对应实数和复数.当$n=2,3,4$分别对应四元数(Hamilton代数),八元数(Cayley代数),以及十六元数(Clifford代数).它们统称为超复数. 当$n\geq 1$时,我们就已经无法比较数的大小,即有序性消失.下面我们就$n=2,3,4$的情况分别讨论. 二. 四元数系$Q(R)$

预告-分享Kaggle上的NFL比赛码数预测

Hello,近期会分享最近的一个Kaggle上的比赛,NFL比赛的码数预测,通过这个比赛还是学到很多,虽然最后分数不理想....这篇分享的内容适用于绝大多于的关于团队竞技类比赛的场景下的预测问题,比如足球.篮球.王者荣耀等等,算是从一个比较通用的角度来看待和分析建模,先附上Kaggle竞赛链接吧,NFL Big Data Bowl 原文地址:https://www.cnblogs.com/helongBlog/p/12182610.html

HDU 1043 Eight八数码解题思路(bfs+hash 打表 IDA* 等)

题目链接 https://vjudge.net/problem/HDU-1043 经典的八数码问题,学过算法的老哥都会拿它练搜索 题意: 给出每行一组的数据,每组数据代表3*3的八数码表,要求程序复原为初始状态 思路: 参加网站比赛时拿到此题目,因为之前写过八数码问题,心中暗喜,于是写出一套暴力bfs+hash,结果TLE呵呵 思路一:bfs+hash(TLE) 1 #include <cstdio> 2 #include <cstring> 3 #include <queu